
#pragma once

#include <cstdint>
#include "State.h"
#include "Random.h"

class StateBlurFire final: public State {
    
    public:
    
        StateBlurFire(const StateBlurFire&) = delete;
        StateBlurFire& operator =(const StateBlurFire&) = delete;
        
        static constexpr StateBlurFire& instance() { return _instance; }
        
        void enter() override;
        
        inline void leave() override {}
        
        void update() override;
    
    private:
    
        StateBlurFire() = default;
        virtual ~StateBlurFire() = default;
        
        static StateBlurFire _instance;
        
        static std::int32_t _frame;
        
        static Random _random;
};
