
#pragma once

#include <cstdint>
#include "State.h"
#include "Random.h"

class StateBufferFire final: public State {
    
    public:
    
        StateBufferFire(const StateBufferFire&) = delete;
        StateBufferFire& operator =(const StateBufferFire&) = delete;
        
        static constexpr StateBufferFire& instance() { return _instance; }
        
        void enter() override;
        
        inline void leave() override {}
        
        void update() override;
    
    private:
    
        StateBufferFire() = default;
        virtual ~StateBufferFire() = default;
        
        static StateBufferFire _instance;
        
        static std::int32_t _frame;
        
        static Random _random;
};
