
#pragma once

#include <cstdint>
#include "State.h"
#include "Random.h"

class StateDirectFire final: public State {
    
    public:
    
        StateDirectFire(const StateDirectFire&) = delete;
        StateDirectFire& operator =(const StateDirectFire&) = delete;
        
        static constexpr StateDirectFire& instance() { return _instance; }
        
        void enter() override;
        
        inline void leave() override {}
        
        void update() override;
    
    private:
    
        StateDirectFire() = default;
        virtual ~StateDirectFire() = default;
        
        static StateDirectFire _instance;
        
        static std::int32_t _frame;
        
        static Random _random;
};
